package at.jku.students.stack;

import at.jku.ssw.Iterator;
import at.jku.ssw.stack.Stack;

public class StackMain {
	public static void main(String[] args) {
		Stack linkedListStack = new ArrayStack();
		StringBuffer sb = new StringBuffer();
		linkedListStack.push("N");
		linkedListStack.push("U");
		linkedListStack.push("H");
		sb.append(linkedListStack.pop());
		linkedListStack.push("A");
		sb.append(linkedListStack.pop());
		linkedListStack.push("D");
		linkedListStack.push("E");
		linkedListStack.push("R");
		sb.append(linkedListStack.pop());
		linkedListStack.pushDown();
		sb.append(linkedListStack.pop());
		linkedListStack.push("Q");
		linkedListStack.push("I");
		linkedListStack.pushDown();
		sb.append(linkedListStack.pop());
		sb.append(linkedListStack.pop());
		linkedListStack.pushDown();
		sb.append(linkedListStack.pop());
		linkedListStack.push("O");
		linkedListStack.push("S");
		sb.append(linkedListStack.peek());
		linkedListStack.pushDown();
		linkedListStack.push("T");
		sb.append(linkedListStack.pop());
		sb.append(linkedListStack.pop());
		sb.append(linkedListStack.pop());
		sb.append(linkedListStack.pop());
		sb.append(linkedListStack.pop());
		System.out.println(sb.toString());
		linkedListStack.push("N");
		linkedListStack.push("U");
		linkedListStack.push("H");
		sb.append(linkedListStack.pop());
		linkedListStack.push("A");
		sb.append(linkedListStack.pop());
		linkedListStack.push("D");
		linkedListStack.push("E");
		linkedListStack.push("R");
		sb.append(linkedListStack.pop());
		linkedListStack.pushDown();
		sb.append(linkedListStack.pop());
		linkedListStack.push("Q");
		linkedListStack.push("I");
		linkedListStack.pushDown();
		sb.append(linkedListStack.pop());
		sb.append(linkedListStack.pop());
		linkedListStack.pushDown();
		sb.append(linkedListStack.pop());
		linkedListStack.push("O");
		linkedListStack.push("S");
		sb.append(linkedListStack.peek());
		linkedListStack.pushDown();
		linkedListStack.push("T");

		System.out.println("Before reverse");
		printStack(linkedListStack);
		linkedListStack.reverse();
		System.out.println("After reverse");
		printStack(linkedListStack);

		System.out.println();

		Stack q = new ArrayStack();
		q.push("A");
		q.push("B");
		q.push("C");
		q.push("D");
		q.push("E");
		System.out.println("Before reverse");
		printStack(q);
		q.reverse();
		System.out.println("After reverse");
		printStack(q);
	}

	public static void printStack(Stack s) {
		Iterator iterator = s.iterator();
		while (iterator.hasNext()) {
			System.out.println(iterator.next());
		}
	}
}
